<?php

/*
 *	ServerSideFilter - ServerSide mail filter plugin for SquirrelMail
 *	By Patrick Swieskowski, Rick Sheaffer, and Jon Stroud
 */



function squirrelmail_plugin_init_serversidefilter() {
  global $squirrelmail_plugin_hooks;

  $squirrelmail_plugin_hooks['optpage_register_block']['serversidefilter'] = 'serversidefilter_optpage_register_block';
  $squirrelmail_plugin_hooks['login_verified']['serversidefilter'] = 'check_filter';
}

function serversidefilter_optpage_register_block() {
	global $optpage_blocks;

        if (defined("SM_PATH")) {
	    bindtextdomain ('serversidefilter', SM_PATH . 'locale');
	} else {
	    bindtextdomain ('serversidefilter', '../locale');
	}
	textdomain ('serversidefilter');

        $optpage_blocks[] = 
		array(
			'name' => _("Mail Filters"),
			'url'  => '../plugins/serversidefilter/options.php',
			'desc' => _("Here you may set up server-side filters on all of your incoming mail."),
			'js'   => FALSE);

	if (defined("SM_PATH")) {
	    bindtextdomain('squirrelmail', SM_PATH . 'locale');
	} else {
	    bindtextdomain ('squirrelmail', '../locale');
	}
	textdomain('squirrelmail');
}

function serversidefilter_version() {

         return '1.42';

}

function check_filter() {
  if (defined('SM_PATH'))
     include_once(SM_PATH . 'plugins/serversidefilter/recipie_functions.php');
  else
     include_once('../plugins/serversidefilter/recipie_functions.php');
  
  if ($ALWAYS_CREATE)
     if (!filter_exists()) create_filter();
}

?>
